# -*- coding: utf-8 -*-
#MoxAlignTangent 161121
#アニメーションカーブの最初と最後のキーを揃えてループモーションを滑らかにする。

import maya.cmds as cmds
	
#メイン
def mat_main():
    
    #情報の取得
    tanMode = cmds.radioButtonGrp('tanMode', q=True, select=True)
    valMode = cmds.radioButtonGrp('valMode', q=True, select=True)
    tanCheck = cmds.checkBox('tanCheck', q=True, v=True)
    valCheck = cmds.checkBox('valCheck', q=True, v=True)
    
    #アニメーションカーブ一覧取得
    curveList = cmds.keyframe(q=True, name=True)
    # iterate through list of animation curves
    for crv in curveList:
        if cmds.keyframe(crv, q=True, kc=True)<2:
            cmds.warning(u"キーが２個以上必要です")
            continue
            
       #タンジェントの処理	
        if tanCheck:
            #タンジェントコピー
            keyInTangents=cmds.keyTangent(crv, q=1, ia=1)
            keyOutTangents=cmds.keyTangent(crv, q=1, oa=1)
            
            #スタートのタンジェントをエンドにコピー
            if tanMode == 1:
                cmds.keyTangent(crv, index=(len(keyInTangents)-1,),  e=1, oa=keyInTangents[0])
                
            #エンドのタンジェントをスタートにコピー	
            elif tanMode == 2:
                cmds.keyTangent(crv, ia=keyOutTangents[- 1], index=(0,), e=1)

        #値の処理	
        if valCheck:
            #値のコピー
            keyValues=cmds.keyframe(crv, q=1, vc=1)
            
            #スタートの値をエンドにコピー
            if valMode == 1:
                cmds.keyframe(crv, index=(len(keyValues) - 1,), vc=keyValues[0], e=1)
            #エンドの値をスタートにコピー	
            elif valMode == 2:
                cmds.keyframe(crv, index=(0,), vc=keyValues[- 1], e=1)	
#UI
class MoxAlignTangent(object):
    def __init__(self):		
        if (cmds.window('MoxAlignTangent', exists=1)) == True:cmds.deleteUI('MoxAlignTangent')
        
        cmds.window('MoxAlignTangent', menuBarVisible=True, title="MoxAlignTangent", maximizeButton=0, 
            resizeToFitChildren=1, 
            mnb=1, mxb=0,tlb=True)
        
        cmds.columnLayout(adjustableColumn=True)
        cmds.checkBox('valCheck',h=20, value=True, label="Value")
        cmds.radioButtonGrp('valMode', nrb=2, columnWidth=[(1, 90), (2, 90)], 
            l1="Start to End", l2="End to Start", select=1)

        cmds.separator(h=12)
        cmds.checkBox('tanCheck',h=20, value=True, label="Tangent")
        cmds.radioButtonGrp('tanMode', nrb=2, columnWidth=[(1, 90), (2, 90)], 
            l1="Start to End",l2="End to Start", select=1)

        cmds.button('run', command="MoxAlignTangent.mat_main()", label="Run")	
        cmds.showWindow('MoxAlignTangent')
mat_mainWind = MoxAlignTangent()	

      